<template>
	<view class="container">
		<cu-custom bgColor="bg-gradual-pink" :isBack="true">
			<block slot="backText">返回</block>
			<block slot="content">单据组盘</block>
		</cu-custom>
		<view class="example">
			<uni-forms ref="form" :model="formData" labelWidth="80px">
				<uni-forms-item label="入库单号" name="invoiceCode">
					<view class="flex-twice  padding-0 radius">
						<uni-easyinput v-model="formData.invoiceCode" placeholder="请输入入库单号" @blur="queryRkOrder" />
					</view>
					<view class="flex-sub padding-0 margin-xs radius">
						<view class="cu-capsule radius" v-if="billInfo.totalPlanQty>0">
							<view class='cu-tag bg-blue '>
								总{{billInfo.totalPlanQty}}
							</view>
							<view class="cu-tag line-blue">
								剩{{billInfo.totalSurplusQty}}
							</view>
						</view>
					</view>
				</uni-forms-item>
				<uni-forms-item label="托盘编号" name="palletCode">
					<uni-easyinput v-model="formData.palletCode" placeholder="请输入托盘号" @blur="trimInput"/>
				</uni-forms-item>
				<uni-forms-item label="仓库编号" name="houseCode">
					<uni-data-select v-model="formData.houseCode" :localdata="warehouseList" placeholder="请选择仓库号">
					</uni-data-select>
				</uni-forms-item>
				<!-- <uni-forms-item label="仓库编号" name="houseCode">
					<uni-easyinput v-model="formData.houseCode" placeholder="请输入仓库号" @blur="queryRkOrder" />
				</uni-forms-item> -->
			</uni-forms>
			<button type="primary" @click="formSubmit">提交</button>
			<view v-if='billInfo.wmsInBillSkuInfos.length>0'>
				<view class="uni-container">
					<uni-table ref="table" :loading="loading" border stripe type="selection" emptyText="暂无更多数据"
						@selection-change="selectionChange">
						<uni-tr>
							<uni-th width="280" align="center">基本信息</uni-th>
							<uni-th width="100" align="center">设置</uni-th>
						</uni-tr>
						<uni-tr v-for="(item, index) in billInfo.wmsInBillSkuInfos" :key="index">
							<uni-td>
								<view class="flex">
									<view class="flex-sub padding-0 margin-xs radius">详情单号</view>
									<view class="flex-twice padding-0 margin-xs radius">{{item.itemCode}}</view>
								</view>
								<view class="flex">
									<view class="flex-sub padding-0 margin-xs radius">物料编号</view>
									<view class="flex-twice padding-0 margin-xs radius">{{item.skuCode}}</view>
								</view>
								<view class="flex">
									<view class="flex-sub padding-0 margin-xs radius">物料描述</view>
									<view class="flex-twice padding-0 margin-xs radius">{{item.skuName}}</view>
								</view>
								<view class="flex">
									<view class="flex-sub padding-0 margin-xs radius">单位</view>
									<view class="flex-twice padding-0 margin-xs radius">{{item.baseUnit}}</view>
								</view>
								<view class="flex">
									<view class="flex-sub padding-0 margin-xs radius">批次号</view>
									<view class="flex-twice padding-0 margin-xs radius">{{item.batch}}</view>
								</view>
								<view class="flex">
									<view class="flex-sub padding-0 margin-xs radius">计划数量</view>
									<view class="flex-twice padding-0 margin-xs radius">{{item.planQty}}</view>
								</view>
								<view class="flex">
									<view class="flex-sub padding-0 margin-xs radius">锁定数量</view>
									<view class="flex-twice padding-0 margin-xs radius">{{item.lockQty}}</view>
								</view>
								<view class="flex">
									<view class="flex-sub padding-0 margin-xs radius">组盘数量</view>
									<view class="flex-twice padding-0 margin-xs radius">
										<input placeholder="请输入组盘数量" v-model="item.qty"></input>
									</view>
								</view>
							</uni-td>
							<view class="uni-group" style="text-align: center;">
								<view class="flex">
									<button class="uni-button" size="mini" type="primary">修改</button>
								</view>
								<view class="flex"><button class="uni-button" size="mini" type="warn">删除</button>
								</view>
							</view>
							</uni-td>
						</uni-tr>
					</uni-table>
					<view class="uni-pagination-box"><uni-pagination show-icon :page-size="pageSize"
							:current="pageCurrent" :total="total" @change="change" /></view>
				</view>
			</view>
		</view>
		<view class="cu-modal" :class="msgModalName=='Modal'?'show':''">
			<view class="cu-dialog">
				<view class="cu-bar bg-white justify-end">
					<view class="content">{{msgTitleName}}</view>
					<view class="action" @tap="hideMsgModal">
						<text class="cuIcon-close text-red"></text>
					</view>
				</view>
				<view class="padding-xl">
					{{msg}}
				</view>
			</view>
		</view>
	</view>

</template>

<script>
	import {
		queryInBillSkuInfo,
		createPalletByBill
	} from "@/api/wms/bill.js"
	import {
		getDictionary
	} from "@/api/wms/dictData.js"
	import {
		formatDate
	} from 'tough-cookie';
	export default {
		data() {
			return {
				//表单中的数据信息	
				formData: {
					invoiceCode: "",
					palletCode: "",
					houseCode: "",
					details: []
				},
				rules: {
					invoiceCode: {
						rules: [{
							required: true,
							errorMessage: '单据号不能为空'
						}]
					},
					palletCode: {
						rules: [{
							required: true,
							errorMessage: '托盘号不能为空'
						}]
					},
					houseCode: {
						rules: [{
							required: true,
							errorMessage: '仓库号不能为空'
						}]
					},
					details: {
						rules: [{
							required: true,
							errorMessage: '物料信息不能为空'
						}]
					},
				},
				
				//查询获取的单据信息
				billInfo: {
					totalPlanQty: 0,
					totalSurplusQty: 0,
					wmsInBillSkuInfos: []
				},
				//table 相关
				searchVal: '',
				tableData: [],
				// 每页数据量
				pageSize: 10,
				// 当前页
				pageCurrent: 1,
				// 数据总量
				total: 0,
				loading: false,
				//tabe选中的数据对象
				selectedIndexs: [],
				// 列配置
				tableClumns: [{
						dataIndex: "itemCode",
						key: "itemCode",
						title: "明细单号"
					},
					{
						dataIndex: "batch",
						key: "batch",
						title: "批次"
					},
					{
						dataIndex: "skuCode",
						key: "skuCode",
						title: "物料编号"
					},
					{
						dataIndex: "skuName",
						key: "skuName",
						title: "物料名称"
					},
					{
						dataIndex: "planQty",
						key: "planQty",
						title: "计划数量"
					},
					{
						dataIndex: "lockQty",
						key: "lockQty",
						title: "锁定数量"
					},
					{
						dataIndex: "qty",
						key: "qty",
						title: "组盘数量"
					},
				],
				
				warehouseList: [],
				skuArray: [],
				skushow: false,
				invoiceCode: null,
				palletCode: null,
				houseCode: null,

				totalPlanQty: null,
				totalSurplusQty: null,

				msgModalName: null,
				msgTitleName: null,
				msg: null
			};
		},
		onLoad() {
			//加载入库单据类型下拉值列表
			this.getWarehouses()
			//this.getInvoicesByBusinessType()
		
		},
		onReady() {
			this.$refs.form.setRules(this.rules)
		},
		methods: {
			//去除空格
			 trimInput(event) {
			      this.formData.palletCode = event.target.value.trim();
			    },
			/// 数据来源 [模拟]
			async fetch(param) {
				var response = await queryInBillSkuInfo(param);
				return {
					total: response.data.total,
					data: response.data.record,
				};
			},
		
			//获取仓库列表
			async getWarehouses() {
				this.warehouseList = await getDictionary('warehouseList');
				console.log("this.warehouseList",this.warehouseList)
			},
			// 多选处理
			selectedItems() {
				return this.selectedIndexs.map(i => this.tableData[i])
			},
			// 多选
			selectionChange(e) {
				console.log(e.detail.index)
				this.selectedIndexs = e.detail.index
				//选中内容改变时获取选中数据

			},
			//批量删除
			delTable() {
				console.log(this.selectedItems())
			},
			// 分页触发
			change(e) {
				this.$refs.table.clearSelection()
				this.selectedIndexs.length = 0
				this.getData(e.current)
			},
			// 搜索
			search() {
				this.getData(1, this.searchVal)
			},
			// 获取数据
			getData(pageCurrent, value = '') {
				this.loading = true
				this.pageCurrent = pageCurrent
				this.request({
					pageSize: this.pageSize,
					pageCurrent: pageCurrent,
					value: value,
					success: res => {
						// console.log('data', res);
						this.tableData = res.data
						this.total = res.total
						this.loading = false
					}
				})
			},
			//获取选中的数据
			getSelectDetail() {
				if (this.selectedIndexs.length == 0) {
					//提示 
					this.$modal.msgError("请先选择需要组盘的单据明细")
					return;
				}
				//筛选出需要拣选的单据明细
				let arr = [];
				let len = this.billInfo.wmsInBillSkuInfos.length;
				for (let i = 0; i < len; i++) {
					if (this.selectedIndexs.indexOf(i) >= 0) {
						arr.push(this.billInfo.wmsInBillSkuInfos[i]);
					} else {
						// console.log(this.selectArr.indexOf(i))
						//this.selectArr.indexOf(i);
					}
				}
				console.log("选中的单据明细数据为", arr.length)
				return arr;
			},

			// 伪request请求
			request(options) {
				const {
					pageSize,
					pageCurrent,
					success,
					value
				} = options
				let total = tableData.length
				let data = tableData.filter((item, index) => {
					const idx = index - (pageCurrent - 1) * pageSize
					return idx < pageSize && idx >= 0
				})
				if (value) {
					data = []
					tableData.forEach(item => {
						if (item.name.indexOf(value) !== -1) {
							data.push(item)
						}
					})
					total = data.length
				}

				setTimeout(() => {
					typeof success === 'function' &&
						success({
							data: data,
							total: total
						})
				}, 500)
			},
			// submit(ref) {
			// 	this.$refs.form.validate().then(res => {
			// 		updateUserProfile(this.user).then(response => {
			// 			this.$modal.msgSuccess("修改成功")
			// 		})
			// 	})
			// }
			//表单提交
			formSubmit: function(ref) {
				//拿到 formaData
				var details = this.getSelectDetail()
				if (details && details.length > 0) {
					this.$refs.form.validate().then(res => {
						console.log("数据校验通过", res)
						this.formData.details = details
						createPalletByBill(this.formData).then(response => {
							console.log("response", response)
							this.$modal.msgSuccess("组盘成功")
						})
					})
				}
			},

			hideMsgModal(e) {
				//关闭信息模态框
				this.msgModalName = null;
			},
			textareaAInput(e) {
				this.textareaAValue = e.detail.value
			},
			textareaBInput(e) {
				this.textareaBValue = e.detail.value
			},
			//根据单据号查询入库单
			queryRkOrder: async function(e) {
				console.log('进入查询方法', e);
				console.log('this.formData', this.formData);
				console.log('this.formData.invoiceCode', this.formData.invoiceCode);
				var invoiceCode = this.formData.invoiceCode;
				if (invoiceCode == null) {
					this.$modal.msgError("单据号不能为空")
					return;
				}
				if (invoiceCode.length < 1) {
					this.$modal.msgError("单据号不能为空")
					return;
				}
				//查询单据信息
				var billInfo = await queryInBillSkuInfo({
					'invoiceCode': invoiceCode
				});
				console.log("billInfo", billInfo)
				if (billInfo) {
					this.billInfo = billInfo.data;
				};
			}
		}
	}
</script>

<style lang="scss">
	.cu-form-group .title {
		min-width: calc(4em + 15px);
	}

	page {
		background-color: #ffffff;
	}

	.example {
		padding: 15px;
		background-color: #fff;
	}

	.segmented-control {
		margin-bottom: 15px;
	}

	.button-group {
		margin-top: 15px;
		display: flex;
		justify-content: space-around;
	}

	.form-item {
		display: flex;
		align-items: center;
		flex: 1;
	}

	.button {
		display: flex;
		align-items: center;
		height: 35px;
		line-height: 35px;
		margin-left: 10px;
	}
</style>